<?php
// +----------------------------------------------------------------------
// | 小黄牛IT分词插件
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------
namespace phpcutting;

class Phpcutting {

    /**
     * 题词分词库
     * @todo 无
     * @author 小黄牛
     * @version v1.2.16 + 2020.10.27
     * @deprecated 暂不启用
     * @global 无
     * @param string $string
     * @return array
    */
    public function run($string) {
        $en = $this->english($string);

        // 删除英文词库
        foreach ($en as $value) {
            $string = str_replace($value, '', $string);
        }

        $string = str_replace([' ', "\r", "\n"], '', $string);

        $zh = $this->mbStrSplit($string);
        
        return array_merge($en, $zh);
    }

    /**
     * 英文分词
     * @todo 无
     * @author 小黄牛
     * @version v1.2.16 + 2020.10.27
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    private function english($string) {
        $parrten = "/[a-zA-Z]+/";
        preg_match_all($parrten,$string,$arr);
        return $arr[0];
    }

    /**
     * 按长度分割成数组
     * @todo 无
     * @author 小黄牛
     * @version v1.2.16 + 2020.10.27
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    private function mbStrSplit($string, $len=2) {
        $start = 0;
        $strlen = mb_strlen($string);
        while ($strlen) {
          $array[] = mb_substr($string,$start,$len,"utf8");
          $string = mb_substr($string, $len, $strlen,"utf8");
          $strlen = mb_strlen($string);
        }
        return $array;
    }

    /**
     * 手动记录有效词库
     * @todo 无
     * @author 小黄牛
     * @version v1.2.16 + 2020.10.27
     * @deprecated 暂不启用
     * @global 无
     * @param string $string 
     * @return void
    */
    public function record($string) {
        $file = dirname(__FILE__).'/txt/cutting.txt';
        $txt = file_get_contents($file);
        if ($txt) {
            $arr = explode('|', $txt);
            foreach ($arr as $v) {
                if ($string == $v) {
                    return false;
                }
            }
            // 追加
            file_put_contents($file, '|'.$string, FILE_APPEND);
        } else {
            file_put_contents($file, $string);
        }

        return true;
    }
}